/* to be put: "samples/scriptedui/ui-oo.rex"    */
/* pick up the center panel bean, Object Rexx program modelled after ui.nrx */
p = .bsf~lookupBean("centerPanel")

/* set the layout manager to border */
p~setLayout("obj", .bsf~new("java.awt.BorderLayout"))

/* add a few things */
p~add("str", "Center", "obj",,
      .bsf~new("java.awt.Label", "str", "Middle from Object Rexx"))

p~add("str", "North",  "obj",,
      .bsf~new("java.awt.Label", "str", "North text from Object Rexx"))

p~add("str", "South",  "obj",,
      .bsf~new("java.awt.Label", "str", "South text from Object Rexx"))

p~add("str", "East",   "obj",,
      .bsf~new("java.awt.Label", "str", "Inner east text from Object Rexx"))

p~add("str", "West",   "obj",,
      .bsf~new("java.awt.Label", "str", "Inner west text from Object Rexx"))

/* configure p a bit */
p~setBackground("obj", .bsf~getStaticValue("java.awt.Color", "green"))

/* configure the frame that p is in */
f=p~getParent
f~setTitle("str", "Hello from Object REXX (title reset from Object Rexx)")

::requires "BSF.cls"    -- get Object Rexx wrapper support for BSF


